#include <bits/stdc++.h>
 
const int MOD=1e9+7;
const int inf=1e9+7;
const int MAXN=100500;
 
using namespace std;
 
int n, L[MAXN], Power10[8]; // Power10[i] = 10 ** i
 
inline int Log10(int x) // Log10(x) = the digit number of x in decimal form
{
    if(x < 10) return 1;
    if(x < 100) return 2;
    if(x < 1000) return 3;
    if(x < 10000) return 4;
    if(x < 100000) return 5;
    if(x < 1000000) return 6;
    else return 7;
}
 
void Init()
{
    for(int i = 0; i < MAXN; i++)
        L[i] = inf;
    L[1]=1;
     
    Power10[0] = 1;
    for(int i = 1; i <= 7; i++)
        Power10[i] = Power10[i - 1] * 10;
}
 
signed main()
{   
    Init();
     
    cin>>n;
     
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j * 2 <= i; j++)
            L[i] = min(L[i], L[j] + L[i - j]); // Use '+' to achieve i from j and i-j
         
        for(int j = 1; j * j <= i; j++)
            if(!(i % j))
                L[i] = min(L[i], L[j] + L[i / j]);
         
        for(int j = 1; Power10[j] <= i; j++)
            if(Log10(i / Power10[j]) + Log10(i % Power10[j]) == Log10(i))
                L[i] = min(L[i], L[i / Power10[j]] + L[i % Power10[j]]);
    }
    cout << L[n] << endl;
     
    return 0;
}